//   Version 2008.08.25
//   Version 2008.10.10,  modified for multi-thread programming


#ifndef MyRNKISS_CK
#define MyRNKISS_CK

using namespace System;

namespace MyRNKISS {

	double sqr( double v );

/****************************************************************

                    The Kiss Algorithm

              See   C.P.Robert and G.Casella
             "Monte Carlo Statistical Methods"
                 1999, Springer-Verlag
                         Pp. 39-43.

******************************************************************/

	class myrn {
    	private:
			unsigned __int32 x, y, z;
			int icycle, ibias;

	    public:
			myrn();
			myrn( int ic, int ib );
			myrn( unsigned __int32 xv, unsigned __int32 yv, unsigned __int32 zv );
		    virtual ~myrn() { }; 

		    unsigned __int32 seek_x(){ return x;};
			unsigned __int32 seek_y(){ return y;};
			unsigned __int32 seek_z(){ return z;};

			void init();
			void init( unsigned __int32 xv, unsigned __int32 yv, unsigned __int32 zv );
			void Init( int ic, int ib );

			double uni0();                           
			double uni();                             //   0.0 < uni()  <= 1.0
			double normal();                          //   Standard Normal Distribution
													  //   Rejection polar method for normal variate
			double normalMS(double m, double s);      //    m : mean,   s : standard deviation  
			void   normalPair( double & n1, double & n2 );   //    pair of independent random numbers of  
			                                                 //             the standard normal distribution 
    };



}

#endif
